// JavaScript for Adobe InDesign CS3. Version 0.2 Copyright (c) Jungle Software 2004 - 2010.

#target indesign

// ==================================== Script Globals ====================================

const JS_IMAGE_ITEM = "Image";
const JS_EPS_ITEM = "EPS";
const JS_PDF_ITEM = "PDF";
const JS_PICT_ITEM = "PICT";

const JS_LOW_RESOLUTION = 300;
const JS_HIGH_RESOLUTION = 450;

// =================================== Common functions ===================================

function JS_IsObjectInArray(JS_objectReference, JS_objectsArray) {
	
	for(var JS_indexI = 0; JS_indexI < JS_objectsArray.length; JS_indexI++)
		
		if(JS_objectReference.id == JS_objectsArray[JS_indexI].id) return true;
	
	return false;
}

function JS_CheckLinkProblem(JS_currentLink) {
	
var JS_currentImage = JS_currentLink.parent;
var JS_linkXmp = JS_currentLink.linkXmp;
	
	if (JS_currentLink.status == LinkStatus.normal) {
		
		if ((JS_currentLink.linkType == "TIFF") || (JS_currentLink.linkType == "Photoshop")) {
		
			if ((JS_currentImage.space == "CMYK")||(JS_currentImage.space == "Grayscale")||(JS_currentImage.space == "Black and White")) {
			
				if (JS_currentImage.profile == "None") {
				
					if ((JS_currentImage.effectivePpi[0] >= JS_LOW_RESOLUTION) && (JS_currentImage.effectivePpi[1] >= JS_LOW_RESOLUTION)
						&& (JS_currentImage.effectivePpi[0] <= JS_HIGH_RESOLUTION) && (JS_currentImage.effectivePpi[1] <= JS_HIGH_RESOLUTION)) {
					
						if(JS_currentImage.clippingPath.clippingType != ClippingPathType.photoshopPath) return false;
						else return true;
					}
					else return true;
				}
				else return true;
			}
			else return true;
		}
		else {
		
			if(JS_currentImage.constructor.name == JS_IMAGE_ITEM) return true;
			else {
			
				if((JS_currentImage.constructor.name == JS_EPS_ITEM)||(JS_currentImage.constructor.name == JS_PDF_ITEM)||(JS_currentImage.constructor.name == JS_PICT_ITEM)) {
			
					try {
						
						if(JS_linkXmp.creator.search("Photoshop") != -1) return true;
						else return false;
					}
				
					catch(anyError) { return false; }
				}
				else return false;
			}
		}
	}
	else {
		
		if(confirm("Continue with modified, missing or embedded link?:\n" + JS_currentLink.filePath, true)) return false;
		else exit();
	}
}

// =================================== Main function ===================================

function main() {
	
var JS_allGraphics = new Array;
var JS_pageItems = new Array;
var JS_workItems = new Array;

var JS_indexI = 0;
var JS_indexJ = 0;

var JS_filesToOpen = new Array;

	if(app.documents.length) {
		
		if(app.activeDocument.selection.length) {
			
			for(JS_indexI = 0; JS_indexI < app.activeDocument.selection.length; JS_indexI++) {
				
				switch (app.activeDocument.selection[JS_indexI].constructor.name) {
					
					case JS_IMAGE_ITEM :
					case JS_EPS_ITEM :
					case JS_PDF_ITEM :
					case JS_PICT_ITEM : JS_allGraphics.push(app.activeDocument.selection[JS_indexI]); break;
							
					default : {
				
						JS_pageItems.push(app.activeDocument.selection[JS_indexI]);
						JS_workItems = app.activeDocument.selection[JS_indexI].allPageItems;
						for(JS_indexJ = 0; JS_indexJ < JS_workItems.length; JS_indexJ++) JS_pageItems.push(JS_workItems[JS_indexJ]);
				
					}  break;
				}
			}
		
			for(JS_indexI = 0; JS_indexI < JS_pageItems.length; JS_indexI++) {
		
				try {
		
					JS_workItems = JS_pageItems[JS_indexI].images;
					for (JS_indexJ = 0; JS_indexJ < JS_workItems.length; JS_indexJ++) {
			
						if(JS_IsObjectInArray(JS_workItems[JS_indexJ], JS_allGraphics)) ;
						else JS_allGraphics.push(JS_workItems[JS_indexJ]);
					}
		
					JS_workItems = JS_pageItems[JS_indexI].epss;
					for (JS_indexJ = 0; JS_indexJ < JS_workItems.length; JS_indexJ++) {
			
						if(JS_IsObjectInArray(JS_workItems[JS_indexJ], JS_allGraphics)) ;
						else JS_allGraphics.push(JS_workItems[JS_indexJ]);
					}
		
					JS_workItems = JS_pageItems[JS_indexI].pdfs;
					for (JS_indexJ = 0; JS_indexJ < JS_workItems.length; JS_indexJ++) {
			
						if(JS_IsObjectInArray(JS_workItems[JS_indexJ], JS_allGraphics)) ;
						else JS_allGraphics.push(JS_workItems[JS_indexJ]);
					}
		
					JS_workItems = JS_pageItems[JS_indexI].picts;
					for (JS_indexJ = 0; JS_indexJ < JS_workItems.length; JS_indexJ++) {
			
						if(JS_IsObjectInArray(JS_workItems[JS_indexJ], JS_allGraphics)) ;
						else JS_allGraphics.push(JS_workItems[JS_indexJ]);
					}
		
				}
		
				catch(anyError) { ; }
			}
		
			for(JS_indexI = 0; JS_indexI < JS_allGraphics.length; JS_indexI++) {
				
				if(JS_CheckLinkProblem(JS_allGraphics[JS_indexI].itemLink))
						
					JS_filesToOpen.push(new File(JS_allGraphics[JS_indexI].itemLink.filePath));
				
				else ;
			}
		}
		else {
			
			for(JS_indexI = 0; JS_indexI < app.activeDocument.links.length; JS_indexI++) {
				
				if(JS_CheckLinkProblem(app.activeDocument.links[JS_indexI])) 
					
					JS_filesToOpen.push(new File(app.activeDocument.links[JS_indexI].filePath));
				
				else ;
			}
		}
	
		if(JS_filesToOpen.length) photoshop.open(JS_filesToOpen);
		else alert("Can't believe! Problem links not found!\n Nice selection or perfect document?..");
	}
	else alert("WTF, Guy?!!\n Open any stupied document and try again!");
}

main();
